scala.collection

# TraversableView

#### trait TraversableView[+A, +Coll] extends TraversableViewLike[A, Coll, TraversableView[A, Coll]] with GenTraversableView[A, Coll]

A base trait for non-strict views of traversable collections.

A view is a lazy version of some collection. Collection transformers such as `map` or `filter` or `++` do not traverse any elements when applied on a view. Instead they create a new view which simply records that fact that the operation needs to be applied. The collection elements are accessed, and the view operations are applied, when a non-view result is needed, or when the `force` method is called on a view.

All views for traversable collections are defined by creating a new `foreach` method.

Source
  TraversableView.scala

Linear Supertypes
GenTraversableView[A, Coll], TraversableViewLike[A, Coll, TraversableView[A, Coll]], GenTraversableViewLike[A, Coll, TraversableView[A, Coll]], ViewMkString[A], Traversable[A], GenTraversable[A], GenericTraversableTemplate[A, Traversable], TraversableLike[A, TraversableView[A, Coll]], GenTraversableLike[A, TraversableView[A, Coll]], Parallelizable[A, ParIterable[A]], TraversableOnce[A], GenTraversableOnce[A], FilterMonadic[A, TraversableView[A, Coll]], HasNewBuilder[A, TraversableView[A, Coll]], AnyRef, Any
Known Subclasses
Appended, Appended, Appended, Appended, DroppedWhile, DroppedWhile, DroppedWhile, DroppedWhile, DroppedWhile, EmptyView, EmptyView, EmptyView, EmptyView, Filtered, Filtered, Filtered, Filtered, Filtered, FlatMapped, FlatMapped, FlatMapped, FlatMapped, Forced, Forced, Forced, Forced, IndexedSeqView, IterableView, IterableViewLike, Mapped, Mapped, Mapped, Mapped, Patched, Patched, Prepended, Prepended, Reversed, Reversed, Reversed, SeqView, SeqViewLike, Sliced, Sliced, Sliced, Sliced, Sliced, StreamView, StreamViewLike, TakenWhile, TakenWhile, TakenWhile, TakenWhile, TakenWhile, Transformed, Transformed, Transformed, Transformed, Transformed, Zipped, Zipped, Zipped, ZippedAll, ZippedAll, ZippedAll
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. TraversableView
2. GenTraversableView
3. TraversableViewLike
4. GenTraversableViewLike
5. ViewMkString
6. Traversable
7. GenTraversable
8. GenericTraversableTemplate
9. TraversableLike
10. GenTraversableLike
11. Parallelizable
12. TraversableOnce
13. GenTraversableOnce
14. FilterMonadic
15. HasNewBuilder
16. AnyRef
17. Any

Visibility

1. Public
2. All

### Type Members

1. #### trait Appended[B >: A] extends Transformed[B] with Appended[B]

   Definition Classes
     TraversableViewLike → GenTraversableViewLike

2. #### trait DroppedWhile extends Transformed[A] with DroppedWhile

   Definition Classes
     TraversableViewLike → GenTraversableViewLike

3. #### trait EmptyView extends Transformed[Nothing] with EmptyView

   Definition Classes
     TraversableViewLike → GenTraversableViewLike

4. #### trait Filtered extends Transformed[A] with Filtered

   Definition Classes
     TraversableViewLike → GenTraversableViewLike

5. #### trait FlatMapped[B] extends Transformed[B] with FlatMapped[B]

   Definition Classes
     TraversableViewLike → GenTraversableViewLike

6. #### trait Forced[B] extends Transformed[B] with Forced[B]

   A fall back which forces everything into a vector and then applies an operation on it.

7. #### trait Mapped[B] extends Transformed[B] with Mapped[B]

   Definition Classes
     TraversableViewLike → GenTraversableViewLike

8. #### type Self = TraversableView[A, Coll]

   The type implementing this traversable

   The type implementing this traversable

   Attributes
     protected
   Definition Classes
     TraversableLike

9. #### trait Sliced extends Transformed[A] with Sliced

   Definition Classes
     TraversableViewLike → GenTraversableViewLike

10. #### trait TakenWhile extends Transformed[A] with TakenWhile

    Definition Classes
      TraversableViewLike → GenTraversableViewLike

11. #### trait Transformed[+B] extends TraversableView[B, Coll] with Transformed[B]

    The implementation base trait of this view.

12. #### class WithFilter extends FilterMonadic[A, Repr]

    A class supporting filtered operations.

### Abstract Value Members

1. #### abstract def foreach[U](f: (A) ⇒ U): Unit

   Applies a function `f` to all elements of this collection.

   Applies a function `f` to all elements of this collection.

   U

     the type parameter describing the result of function `f`. This result will always be ignored. Typically `U` is `Unit`, but this is not necessary.

   f

     the function that is applied for its side-effect to every element. The result of function `f` is discarded.

   Definition Classes
     GenericTraversableTemplate

2. #### abstract def underlying: Coll

   Attributes
     protected
   Definition Classes
     TraversableViewLike → GenTraversableViewLike

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### abstract def ++[B](that: GenTraversableOnce[B]): CC[B]

   [use case] Returns a new collection containing the elements from the left hand operand followed by the elements from the right hand operand.

   [use case]

   Returns a new collection containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the collection is the most specific superclass encompassing the element types of the two operands (see example).

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new collection of type `That` which contains all elements of this collection followed by all elements of `that`.

   Definition Classes
     GenTraversableLike

5. #### def ++[B >: A, That](xs: GenTraversableOnce[B])(implicit bf: CanBuildFrom[TraversableView[A, Coll], B, That]): That

   Returns a new collection containing the elements from the left hand operand followed by the elements from the right hand operand.

   Returns a new collection containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the collection is the most specific superclass encompassing the element types of the two operands (see example).

   Example:

           scala> val a = LinkedList(1)
           a: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

           scala> val b = LinkedList(2)
           b: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val c = a ++ b
           c: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

           scala> val d = LinkedList('a')
           d: scala.collection.mutable.LinkedList[Char] = LinkedList(a)

           scala> val e = c ++ d
           e: scala.collection.mutable.LinkedList[AnyVal] = LinkedList(1, 2, a)

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

   returns

     a new collection of type `That` which contains all elements of this collection followed by all elements of `that`.

   Definition Classes
     TraversableViewLike → TraversableLike → GenTraversableLike

6. #### def ++:[B >: A, That](that: Traversable[B])(implicit bf: CanBuildFrom[TraversableView[A, Coll], B, That]): That

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand. It differs from `++` in that the right operand determines the type of the resulting collection rather than the left one.

   Example:

           scala> val x = List(1)
           x: List[Int] = List(1)

           scala> val y = LinkedList(2)
           y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val z = x ++: y
           z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   This overload exists because: for the implementation of `++:` we should reuse that of `++` because many collections override it with more efficient versions.

   Since `TraversableOnce` has no `++` method, we have to implement that directly, but `Traversable` and down can use the overload.

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

   returns

     a new collection which contains all elements of this collection followed by all elements of `that`.

   Definition Classes
     TraversableLike

7. #### abstract def ++:[B](that: TraversableOnce[B]): CC[B]

   [use case] Concatenates this collection with the elements of a traversable collection.

   [use case]

   Concatenates this collection with the elements of a traversable collection. It differs from ++ in that the right operand determines the type of the resulting collection rather than the left one.

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new collection of type `That` which contains all elements of this collection followed by all elements of `that`.

   Definition Classes
     TraversableLike

8. #### def ++:[B >: A, That](that: TraversableOnce[B])(implicit bf: CanBuildFrom[TraversableView[A, Coll], B, That]): That

   Concatenates this collection with the elements of a traversable collection.

   Concatenates this collection with the elements of a traversable collection. It differs from ++ in that the right operand determines the type of the resulting collection rather than the left one.

   Example:

           scala> val x = List(1)
           x: List[Int] = List(1)

           scala> val y = LinkedList(2)
           y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val z = x ++: y
           z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

   returns

     a new collection of type `That` which contains all elements of this collection followed by all elements of `that`.

   Definition Classes
     TraversableLike

9. #### def /:[B](z: B)(op: (B, A) ⇒ B): B

   Applies a binary operator to a start value and all elements of this collection, going left to right.

   Applies a binary operator to a start value and all elements of this collection, going left to right.

   Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

            scala> val a = LinkedList(1,2,3,4)
            a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

            scala> val b = (5 /: a)(_+_)
            b: Int = 15

            scala> val c = (5 /: a)((x,y) => x + y)
            c: Int = 15

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

   B

     the result type of the binary operator.

   z

     the start value.

   op

     the binary operator.

   returns

     the result of inserting `op` between consecutive elements of this collection, going left to right with the start value `z` on the left:

                     op(...op(op(z, x1), x2), ..., xn)

     where `x1, ..., xn` are the elements of this collection.

   Definition Classes
     TraversableOnce → GenTraversableOnce

10. #### def /:\[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

    A syntactic sugar for out of order folding.

    A syntactic sugar for out of order folding. See `fold`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (a /:\ 5)(_+_)
             b: Int = 15

    Definition Classes
      GenTraversableOnce

11. #### def :\[B](z: B)(op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this collection and a start value, going right to left.

    Applies a binary operator to all elements of this collection and a start value, going right to left.

    Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (a :\ 5)(_+_)
             b: Int = 15

             scala> val c = (a :\ 5)((x,y) => x + y)
             c: Int = 15

    B

      the result type of the binary operator.

    z

      the start value

    op

      the binary operator

    returns

      the result of inserting `op` between consecutive elements of this collection, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this collection.

    Definition Classes
      TraversableOnce → GenTraversableOnce

12. #### final def ==(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

13. #### final def ==(arg0: Any): Boolean

    Test two objects for equality.

    Test two objects for equality.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any

14. #### def addString(b: StringBuilder, start: String, sep: String, end: String): StringBuilder

    Definition Classes
      ViewMkString

15. #### def addString(b: StringBuilder): StringBuilder

    Appends all elements of this collection to a string builder.

    Appends all elements of this collection to a string builder. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this collection without any separator string.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> val h = a.addString(b)
             b: StringBuilder = 1234

    b

      the string builder to which elements are appended.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

16. #### def addString(b: StringBuilder, sep: String): StringBuilder

    Appends all elements of this collection to a string builder using a separator string.

    Appends all elements of this collection to a string builder using a separator string. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this collection, separated by the string `sep`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> a.addString(b, ", ")
             res0: StringBuilder = 1, 2, 3, 4

    b

      the string builder to which elements are appended.

    sep

      the separator string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

17. #### def aggregate[B](z: B)(seqop: (B, A) ⇒ B, combop: (B, B) ⇒ B): B

    Aggregates the results of applying an operator to subsequent elements.

    Aggregates the results of applying an operator to subsequent elements.

    This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked an arbitrary number of times.

    For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the list, while `combop` would concatenate two lists from different partitions together. The initial value `z` would be an empty set.

           pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

    Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

    B

      the type of accumulated results

    z

      the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation)

    seqop

      an operator used to accumulate results within a partition

    combop

      an associative operator used to combine results from different partitions

    Definition Classes
      TraversableOnce → GenTraversableOnce

18. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

19. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

20. #### abstract def collect[B](pf: PartialFunction[A, B]): CC[B]

    [use case] Builds a new collection by applying a partial function to all elements of this collection on which the function is defined.

    [use case]

    Builds a new collection by applying a partial function to all elements of this collection on which the function is defined.

    B

      the element type of the returned collection.

    pf

      the partial function which filters and maps the collection.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      GenTraversableLike

21. #### def collect[B, That](pf: PartialFunction[A, B])(implicit bf: CanBuildFrom[TraversableView[A, Coll], B, That]): That

    Builds a new collection by applying a partial function to all elements of this collection on which the function is defined.

    Builds a new collection by applying a partial function to all elements of this collection on which the function is defined.

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    pf

      the partial function which filters and maps the collection.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      TraversableViewLike → TraversableLike → GenTraversableLike

22. #### def collectFirst[B](pf: PartialFunction[A, B]): Option[B]

    Finds the first element of the collection for which the given partial function is defined, and applies the partial function to it.

    Finds the first element of the collection for which the given partial function is defined, and applies the partial function to it.

    Note: may not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    pf

      the partial function

    returns

      an option value containing pf applied to the first value for which it is defined, or `None` if none exists.

    Definition Classes
      TraversableOnce
    Example:

    1. `Seq("a", 1, 5L).collectFirst({ case x: Int => x*10 }) = Some(10)`

23. #### def companion: GenericCompanion[Traversable]

    The factory companion object that builds instances of class CC.

    The factory companion object that builds instances of class CC. (or its `Iterable` superclass where class CC is not a `Seq`.)

    Definition Classes
      Traversable → GenTraversable → GenericTraversableTemplate

24. #### abstract def copyToArray(xs: Array[A], start: Int, len: Int): Unit

    [use case] Copies elements of this collection to an array.

    [use case]

    Copies elements of this collection to an array. Fills the given array `xs` with at most `len` elements of this collection, starting at position `start`. Copying will stop once either the end of the current collection is reached, or the end of the array is reached, or `len` elements have been copied.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      TraversableLike

25. #### def copyToArray[B >: A](xs: Array[B], start: Int, len: Int): Unit

    Copies elements of this collection to an array.

    Copies elements of this collection to an array. Fills the given array `xs` with at most `len` elements of this collection, starting at position `start`. Copying will stop once either the end of the current collection is reached, or the end of the array is reached, or `len` elements have been copied.

    Note: will not terminate for infinite-sized collections.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      TraversableLike → TraversableOnce → GenTraversableOnce

26. #### abstract def copyToArray(xs: Array[A]): Unit

    [use case] Copies values of this collection to an array.

    [use case]

    Copies values of this collection to an array. Fills the given array `xs` with values of this collection. Copying will stop once either the end of the current collection is reached, or the end of the array is reached.

    xs

      the array to fill.

    Definition Classes
      GenTraversableOnce

27. #### def copyToArray[B >: A](xs: Array[B]): Unit

    Copies values of this collection to an array.

    Copies values of this collection to an array. Fills the given array `xs` with values of this collection. Copying will stop once either the end of the current collection is reached, or the end of the array is reached.

    Note: will not terminate for infinite-sized collections.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    Definition Classes
      TraversableOnce → GenTraversableOnce

28. #### abstract def copyToArray(xs: Array[A], start: Int): Unit

    [use case] Copies values of this collection to an array.

    [use case]

    Copies values of this collection to an array. Fills the given array `xs` with values of this collection, beginning at index `start`. Copying will stop once either the end of the current collection is reached, or the end of the array is reached.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      GenTraversableOnce

29. #### def copyToArray[B >: A](xs: Array[B], start: Int): Unit

    Copies values of this collection to an array.

    Copies values of this collection to an array. Fills the given array `xs` with values of this collection, beginning at index `start`. Copying will stop once either the end of the current collection is reached, or the end of the array is reached.

    Note: will not terminate for infinite-sized collections.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      TraversableOnce → GenTraversableOnce

30. #### def copyToBuffer[B >: A](dest: Buffer[B]): Unit

    Copies all elements of this collection to a buffer.

    Copies all elements of this collection to a buffer.

    Note: will not terminate for infinite-sized collections.

    dest

      The buffer to which elements are copied.

    Definition Classes
      TraversableOnce

31. #### def count(p: (A) ⇒ Boolean): Int

    Counts the number of elements in the collection which satisfy a predicate.

    Counts the number of elements in the collection which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

32. #### def drop(n: Int): TraversableView[A, Coll]

    Selects all elements except first n ones.

    Selects all elements except first n ones.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    n

      the number of elements to drop from this collection.

    returns

      a collection consisting of all elements of this collection except the first `n` ones, or else the empty collection, if this collection has less than `n` elements.

    Definition Classes
      TraversableViewLike → TraversableLike → GenTraversableLike

33. #### def dropWhile(p: (A) ⇒ Boolean): TraversableView[A, Coll]

    Drops longest prefix of elements that satisfy a predicate.

    Drops longest prefix of elements that satisfy a predicate.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    p

      The predicate used to test elements.

    returns

      the longest suffix of this collection whose first element does not satisfy the predicate `p`.

    Definition Classes
      TraversableViewLike → TraversableLike → GenTraversableLike

34. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

35. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. See equals in Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

36. #### def exists(p: (A) ⇒ Boolean): Boolean

    Tests whether a predicate holds for some of the elements of this collection.

    Tests whether a predicate holds for some of the elements of this collection.

    Note: may not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for some of the elements of this collection, otherwise `false`.

    Definition Classes
      TraversableLike → TraversableOnce → GenTraversableOnce

37. #### def filter(p: (A) ⇒ Boolean): TraversableView[A, Coll]

    Selects all elements of this collection which satisfy a predicate.

    Selects all elements of this collection which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new collection consisting of all elements of this collection that satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableViewLike → TraversableLike → GenTraversableLike

38. #### def filterNot(p: (A) ⇒ Boolean): TraversableView[A, Coll]

    Selects all elements of this collection which do not satisfy a predicate.

    Selects all elements of this collection which do not satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new collection consisting of all elements of this collection that do not satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

39. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

40. #### def find(p: (A) ⇒ Boolean): Option[A]

    Finds the first element of the collection satisfying a predicate, if any.

    Finds the first element of the collection satisfying a predicate, if any.

    Note: may not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    p

      the predicate used to test elements.

    returns

      an option value containing the first element in the collection that satisfies `p`, or `None` if none exists.

    Definition Classes
      TraversableLike → TraversableOnce → GenTraversableOnce

41. #### abstract def flatMap[B](f: (A) ⇒ GenTraversableOnce[B]): CC[B]

    [use case] Builds a new collection by applying a function to all elements of this collection and using the elements of the resulting collections.

    [use case]

    Builds a new collection by applying a function to all elements of this collection and using the elements of the resulting collections. For example:

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this collection and concatenating the results.

    Definition Classes
      GenTraversableLike

42. #### def flatMap[B, That](f: (A) ⇒ GenTraversableOnce[B])(implicit bf: CanBuildFrom[TraversableView[A, Coll], B, That]): That

    Builds a new collection by applying a function to all elements of this collection and using the elements of the resulting collections.

    Builds a new collection by applying a function to all elements of this collection and using the elements of the resulting collections. For example:

         def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

    The type of the resulting collection is guided by the static type of collection. This might cause unexpected results sometimes. For example:

         // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
         def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

         // lettersOf will return a Set[Char], not a Seq
         def lettersOf(words: Seq[String]) = words.toSet flatMap (word => word.toSeq)

         // xs will be a an Iterable[Int]
         val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

         // ys will be a Map[Int, Int]
         val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    f

      the function to apply to each element.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this collection and concatenating the results.

    Definition Classes
      TraversableViewLike → TraversableLike → GenTraversableLike → FilterMonadic

43. #### abstract def flatten[B]: CC[B]

    [use case] Converts this collection of traversable collections into a collection formed by the elements of these traversable collections.

    [use case]

    Converts this collection of traversable collections into a collection formed by the elements of these traversable collections.

    B

      the type of the elements of each traversable collection.

    returns

      a new collection resulting from concatenating all element collections.

    Definition Classes
      GenericTraversableTemplate

44. #### def fold[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

    Folds the elements of this collection using the specified associative binary operator.

    Folds the elements of this collection using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      a type parameter for the binary operator, a supertype of `A`.

    z

      a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication.)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

    Definition Classes
      TraversableOnce → GenTraversableOnce

45. #### def foldLeft[B](z: B)(op: (B, A) ⇒ B): B

    Applies a binary operator to a start value and all elements of this collection, going left to right.

    Applies a binary operator to a start value and all elements of this collection, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this collection, going left to right with the start value `z` on the left:

                      op(...op(z, x1), x2, ..., xn)

      where `x1, ..., xn` are the elements of this collection.

    Definition Classes
      TraversableOnce → GenTraversableOnce

46. #### def foldRight[B](z: B)(op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this collection and a start value, going right to left.

    Applies a binary operator to all elements of this collection and a start value, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this collection, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this collection.

    Definition Classes
      TraversableOnce → GenTraversableOnce

47. #### def forall(p: (A) ⇒ Boolean): Boolean

    Tests whether a predicate holds for all elements of this collection.

    Tests whether a predicate holds for all elements of this collection.

    Note: may not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for all elements of this collection, otherwise `false`.

    Definition Classes
      TraversableLike → TraversableOnce → GenTraversableOnce

48. #### def force[B >: A, That](implicit bf: CanBuildFrom[Coll, B, That]): That

    Definition Classes
      TraversableViewLike → GenTraversableViewLike

49. #### abstract def foreach(f: (A) ⇒ Unit): Unit

    [use case] Applies a function `f` to all elements of this collection.

    [use case]

    Applies a function `f` to all elements of this collection.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      GenericTraversableTemplate

50. #### def genericBuilder[B]: Builder[B, Traversable[B]]

    The generic builder that builds instances of CC at arbitrary element types.

    The generic builder that builds instances of CC at arbitrary element types.

    Definition Classes
      GenericTraversableTemplate

51. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

52. #### def groupBy[K](f: (A) ⇒ K): Map[K, TraversableView[A, Coll]]

    Partitions this collection into a map of collections according to some discriminator function.

    Partitions this collection into a map of collections according to some discriminator function.

    Note: this method is not re-implemented by views. This means when applied to a view it will always force the view and return a new collection.

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to collections such that the following invariant holds:

                          (xs partition f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a collection of those elements `x` for which `f(x)` equals `k`.

    Definition Classes
      TraversableViewLike → TraversableLike → GenTraversableLike

53. #### def hasDefiniteSize: Boolean

    Tests whether this collection is known to have a finite size.

    Tests whether this collection is known to have a finite size. All strict collections are known to have finite size. For a non-strict collection such as `Stream`, the predicate returns `true` if all elements have been computed. It returns `false` if the stream is not yet evaluated to the end.

    Note: many collection methods will not work on collections of infinite sizes.

    returns

      `true` if this collection is known to have finite size, `false` otherwise.

    Definition Classes
      TraversableLike → TraversableOnce → GenTraversableOnce

54. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

55. #### def head: A

    Selects the first element of this collection.

    Selects the first element of this collection.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the first element of this collection.

    Definition Classes
      TraversableLike → GenTraversableLike
    Exceptions thrown
      `NoSuchElementException`

      if the collection is empty.

56. #### def headOption: Option[A]

    Optionally selects the first element.

    Optionally selects the first element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the first element of this collection if it is nonempty, `None` if it is empty.

    Definition Classes
      TraversableLike

57. #### def init: TraversableView[A, Coll]

    Selects all elements except the last.

    Selects all elements except the last.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      a collection consisting of all elements of this collection except the last one.

    Definition Classes
      TraversableViewLike → TraversableLike
    Exceptions thrown
      `UnsupportedOperationException`

      if the collection is empty.

58. #### def inits: Iterator[TraversableView[A, Coll]]

    Iterates over the inits of this collection.

    Iterates over the inits of this collection. The first value will be this collection and the final one will be an empty collection, with the intervening values the results of successive applications of `init`.

    returns

      an iterator over all the inits of this collection

    Definition Classes
      TraversableLike
    Example:

    1. `List(1,2,3).inits = Iterator(List(1,2,3), List(1,2), List(1), Nil)`

59. #### def isEmpty: Boolean

    Tests whether this collection is empty.

    Tests whether this collection is empty.

    returns

      `true` if the collection contain no elements, `false` otherwise.

    Definition Classes
      TraversableLike → TraversableOnce → GenTraversableOnce

60. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

61. #### final def isTraversableAgain: Boolean

    Tests whether this collection can be repeatedly traversed.

    Tests whether this collection can be repeatedly traversed.

    returns

      `true`

    Definition Classes
      GenTraversableLike → GenTraversableOnce

62. #### def last: A

    Selects the last element.

    Selects the last element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      The last element of this collection.

    Definition Classes
      TraversableLike
    Exceptions thrown
      NoSuchElementException

      If the collection is empty.

63. #### def lastOption: Option[A]

    Optionally selects the last element.

    Optionally selects the last element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the last element of this collection$ if it is nonempty, `None` if it is empty.

    Definition Classes
      TraversableLike

64. #### abstract def map[B](f: (A) ⇒ B): CC[B]

    [use case] Builds a new collection by applying a function to all elements of this collection.

    [use case]

    Builds a new collection by applying a function to all elements of this collection.

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new collection of type `That` resulting from applying the given function `f` to each element of this collection and collecting the results.

    Definition Classes
      GenTraversableLike

65. #### def map[B, That](f: (A) ⇒ B)(implicit bf: CanBuildFrom[TraversableView[A, Coll], B, That]): That

    Builds a new collection by applying a function to all elements of this collection.

    Builds a new collection by applying a function to all elements of this collection.

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    f

      the function to apply to each element.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the given function `f` to each element of this collection and collecting the results.

    Definition Classes
      TraversableViewLike → TraversableLike → GenTraversableLike → FilterMonadic

66. #### abstract def max: A

    [use case] Finds the largest element.

    [use case]

    Finds the largest element.

    returns

      the largest element of this collection with respect to the ordering `cmp`.

    Definition Classes
      GenTraversableOnce

67. #### def max[B >: A](implicit cmp: Ordering[B]): A

    Finds the largest element.

    Finds the largest element.

    B

      The type over which the ordering is defined.

    cmp

      An ordering to be used for comparing elements.

    returns

      the largest element of this collection with respect to the ordering `cmp`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

68. #### def maxBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

    Definition Classes
      TraversableOnce → GenTraversableOnce

69. #### abstract def min: A

    [use case] Finds the smallest element.

    [use case]

    Finds the smallest element.

    returns

      the smallest element of this collection with respect to the ordering `cmp`.

    Definition Classes
      GenTraversableOnce

70. #### def min[B >: A](implicit cmp: Ordering[B]): A

    Finds the smallest element.

    Finds the smallest element.

    B

      The type over which the ordering is defined.

    cmp

      An ordering to be used for comparing elements.

    returns

      the smallest element of this collection with respect to the ordering `cmp`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

71. #### def minBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

    Definition Classes
      TraversableOnce → GenTraversableOnce

72. #### def mkString(start: String, sep: String, end: String): String

    Definition Classes
      ViewMkString

73. #### def mkString(sep: String): String

    Definition Classes
      ViewMkString

74. #### def mkString: String

    Definition Classes
      ViewMkString

75. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

76. #### def newAppended[B >: A](that: GenTraversable[B]): Transformed[B]

    Attributes
      protected
    Definition Classes
      TraversableViewLike

77. #### def newBuilder: Builder[A, TraversableView[A, Coll]]

    The builder that builds instances of type CC[A]

    The builder that builds instances of type CC[A]

    Attributes
      protected[this]
    Definition Classes
      TraversableViewLike → GenericTraversableTemplate → TraversableLike → HasNewBuilder

78. #### def newDropped(n: Int): Transformed[A]

    Attributes
      protected
    Definition Classes
      TraversableViewLike

79. #### def newDroppedWhile(p: (A) ⇒ Boolean): Transformed[A]

    Attributes
      protected
    Definition Classes
      TraversableViewLike

80. #### def newFiltered(p: (A) ⇒ Boolean): Transformed[A]

    Attributes
      protected
    Definition Classes
      TraversableViewLike

81. #### def newFlatMapped[B](f: (A) ⇒ GenTraversableOnce[B]): Transformed[B]

    Attributes
      protected
    Definition Classes
      TraversableViewLike

82. #### def newForced[B](xs: ⇒ GenSeq[B]): Transformed[B]

    Boilerplate method, to override in each subclass This method could be eliminated if Scala had virtual classes

    Boilerplate method, to override in each subclass This method could be eliminated if Scala had virtual classes

    Attributes
      protected
    Definition Classes
      TraversableViewLike

83. #### def newMapped[B](f: (A) ⇒ B): Transformed[B]

    Attributes
      protected
    Definition Classes
      TraversableViewLike

84. #### def newSliced(_endpoints: SliceInterval): Transformed[A]

    Attributes
      protected
    Definition Classes
      TraversableViewLike

85. #### def newTaken(n: Int): Transformed[A]

    Attributes
      protected
    Definition Classes
      TraversableViewLike

86. #### def newTakenWhile(p: (A) ⇒ Boolean): Transformed[A]

    Attributes
      protected
    Definition Classes
      TraversableViewLike

87. #### def nonEmpty: Boolean

    Tests whether the collection is not empty.

    Tests whether the collection is not empty.

    returns

      `true` if the collection contains at least one element, `false` otherwise.

    Definition Classes
      TraversableOnce → GenTraversableOnce

88. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

89. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

90. #### def par: ParIterable[A]

    Returns a parallel implementation of this collection.

    Returns a parallel implementation of this collection.

    For most collection types, this method creates a new parallel collection by copying all the elements. For these collection, `par` takes linear time. Mutable collections in this category do not produce a mutable parallel collection that has the same underlying dataset, so changes in one collection will not be reflected in the other one.

    Specific collections (e.g. `ParArray` or `mutable.ParHashMap`) override this default behaviour by creating a parallel collection which shares the same underlying dataset. For these collections, `par` takes constant or sublinear time.

    All parallel collections return a reference to themselves.

    returns

      a parallel implementation of this collection

    Definition Classes
      Parallelizable

91. #### def parCombiner: Combiner[A, ParIterable[A]]

    The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

    The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

    returns

      a combiner for the parallel collection of type `ParRepr`

    Attributes
      protected[this]
    Definition Classes
      TraversableLike → Parallelizable

92. #### def partition(p: (A) ⇒ Boolean): (TraversableView[A, Coll], TraversableView[A, Coll])

    Partitions this collection in two collections according to a predicate.

    Partitions this collection in two collections according to a predicate.

    p

      the predicate on which to partition.

    returns

      a pair of collections: the first collection consists of all elements that satisfy the predicate `p` and the second collection consists of all elements that don't. The relative order of the elements in the resulting collections is the same as in the original collection.

    Definition Classes
      TraversableViewLike → TraversableLike → GenTraversableLike

93. #### abstract def product: A

    [use case] Multiplies up the elements of this collection.

    [use case]

    Multiplies up the elements of this collection.

    returns

      the product of all elements of this collection with respect to the `*` operator in `num`.

    Definition Classes
      GenTraversableOnce

94. #### def product[B >: A](implicit num: Numeric[B]): B

    Multiplies up the elements of this collection.

    Multiplies up the elements of this collection.

    B

      the result type of the `*` operator.

    num

      an implicit parameter defining a set of numeric operations which includes the `*` operator to be used in forming the product.

    returns

      the product of all elements of this collection with respect to the `*` operator in `num`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

95. #### def reduce[A1 >: A](op: (A1, A1) ⇒ A1): A1

    Reduces the elements of this collection using the specified associative binary operator.

    Reduces the elements of this collection using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      A type parameter for the binary operator, a supertype of `A`.

    op

      A binary operator that must be associative.

    returns

      The result of applying reduce operator `op` between all the elements if the collection is nonempty.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Exceptions thrown
      UnsupportedOperationException

      if this collection is empty.

96. #### def reduceLeft[B >: A](op: (B, A) ⇒ B): B

    Definition Classes
      TraversableOnce

97. #### def reduceLeftOption[B >: A](op: (B, A) ⇒ B): Option[B]

    Optionally applies a binary operator to all elements of this collection, going left to right.

    Optionally applies a binary operator to all elements of this collection, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceLeft(op)` is this collection is nonempty, `None` otherwise.

    Definition Classes
      TraversableOnce → GenTraversableOnce

98. #### def reduceOption[A1 >: A](op: (A1, A1) ⇒ A1): Option[A1]

    Reduces the elements of this collection, if any, using the specified associative binary operator.

    Reduces the elements of this collection, if any, using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      A type parameter for the binary operator, a supertype of `A`.

    op

      A binary operator that must be associative.

    returns

      An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

    Definition Classes
      TraversableOnce → GenTraversableOnce

99. #### def reduceRight[B >: A](op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this collection, going right to left.

    Applies a binary operator to all elements of this collection, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this collection, going right to left:

                      op(x,,1,,, op(x,,2,,, ..., op(x,,n-1,,, x,,n,,)...))

      where `x1, ..., xn` are the elements of this collection.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Exceptions thrown
      `UnsupportedOperationException`

      if this collection is empty.

100. #### def reduceRightOption[B >: A](op: (A, B) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this collection, going right to left.

     Optionally applies a binary operator to all elements of this collection, going right to left.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceRight(op)` is this collection is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

101. #### def repr: TraversableView[A, Coll]

     The collection of type collection underlying this `TraversableLike` object.

     The collection of type collection underlying this `TraversableLike` object. By default this is implemented as the `TraversableLike` object itself, but this can be overridden.

     Definition Classes
       TraversableLike → GenTraversableLike

102. #### def reversed: List[A]

     Attributes
       protected[this]
     Definition Classes
       TraversableOnce

103. #### def scan[B >: A, That](z: B)(op: (B, B) ⇒ B)(implicit cbf: CanBuildFrom[TraversableView[A, Coll], B, That]): That

     Computes a prefix scan of the elements of the collection.

     Computes a prefix scan of the elements of the collection.

     Note: The neutral element `z` may be applied more than once.

     B

       element type of the resulting collection

     That

       type of the resulting collection

     z

       neutral element for the operator `op`

     op

       the associative operator for the scan

     cbf

       combiner factory which provides a combiner

     returns

       a new collection containing the prefix scan of the elements in this collection

     Definition Classes
       TraversableLike → GenTraversableLike

104. #### def scanLeft[B, That](z: B)(op: (B, A) ⇒ B)(implicit bf: CanBuildFrom[TraversableView[A, Coll], B, That]): That

     Produces a collection containing cummulative results of applying the operator going left to right.

     Produces a collection containing cummulative results of applying the operator going left to right.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableViewLike → TraversableLike → GenTraversableLike

105. #### def scanRight[B, That](z: B)(op: (A, B) ⇒ B)(implicit bf: CanBuildFrom[TraversableView[A, Coll], B, That]): That

     Produces a collection containing cummulative results of applying the operator going right to left.

     Produces a collection containing cummulative results of applying the operator going right to left. The head of the collection is the last cummulative result.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     Example:

            List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableViewLike → TraversableLike → GenTraversableLike
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) The behavior of `scanRight` has changed. The previous behavior can be reproduced with scanRight.reverse.

106. #### def seq: Traversable[A]

     A version of this collection with all of the operations implemented sequentially (i.

     A version of this collection with all of the operations implemented sequentially (i.e. in a single-threaded manner).

     This method returns a reference to this collection. In parallel collections, it is redefined to return a sequential implementation of this collection. In both cases, it has O(1) complexity.

     returns

       a sequential view of the collection.

     Definition Classes
       Traversable → GenTraversable → Parallelizable → TraversableOnce → GenTraversableOnce

107. #### def size: Int

     The size of this collection.

     The size of this collection.

     Note: will not terminate for infinite-sized collections.

     returns

       the number of elements in this collection.

     Definition Classes
       TraversableOnce → GenTraversableOnce

108. #### def slice(from: Int, until: Int): TraversableView[A, Coll]

     Selects an interval of elements.

     Selects an interval of elements. The returned collection is made up of all elements `x` which satisfy the invariant:

            from <= indexOf(x) < until

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     from

       the lowest index to include from this collection.

     until

       the highest index to EXCLUDE from this collection.

     returns

       a collection containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this collection.

     Definition Classes
       TraversableViewLike → TraversableLike → GenTraversableLike

109. #### def span(p: (A) ⇒ Boolean): (TraversableView[A, Coll], TraversableView[A, Coll])

     Splits this collection into a prefix/suffix pair according to a predicate.

     Splits this collection into a prefix/suffix pair according to a predicate.

     Note: `c span p` is equivalent to (but possibly more efficient than) `(c takeWhile p, c dropWhile p)`, provided the evaluation of the predicate `p` does not cause any side-effects.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     p

       the test predicate

     returns

       a pair consisting of the longest prefix of this collection whose elements all satisfy `p`, and the rest of this collection.

     Definition Classes
       TraversableViewLike → TraversableLike → GenTraversableLike

110. #### def splitAt(n: Int): (TraversableView[A, Coll], TraversableView[A, Coll])

     Splits this collection into two at a given position.

     Splits this collection into two at a given position. Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       the position at which to split.

     returns

       a pair of collections consisting of the first `n` elements of this collection, and the other elements.

     Definition Classes
       TraversableViewLike → TraversableLike → GenTraversableLike

111. #### def stringPrefix: String

     Defines the prefix of this object's `toString` representation.

     Defines the prefix of this object's `toString` representation.

     returns

       a string representation which starts the result of `toString` applied to this collection. By default the string prefix is the simple name of the collection class collection.

     Definition Classes
       TraversableViewLike → TraversableLike → GenTraversableLike

112. #### abstract def sum: A

     [use case] Sums up the elements of this collection.

     [use case]

     Sums up the elements of this collection.

     returns

       the sum of all elements of this collection with respect to the `+` operator in `num`.

     Definition Classes
       GenTraversableOnce

113. #### def sum[B >: A](implicit num: Numeric[B]): B

     Sums up the elements of this collection.

     Sums up the elements of this collection.

     B

       the result type of the `+` operator.

     num

       an implicit parameter defining a set of numeric operations which includes the `+` operator to be used in forming the sum.

     returns

       the sum of all elements of this collection with respect to the `+` operator in `num`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

114. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

115. #### def tail: TraversableView[A, Coll]

     Selects all elements except the first.

     Selects all elements except the first.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     returns

       a collection consisting of all elements of this collection except the first one.

     Definition Classes
       TraversableLike → GenTraversableLike
     Exceptions thrown
       `UnsupportedOperationException`

       if the collection is empty.

116. #### def tails: Iterator[TraversableView[A, Coll]]

     Iterates over the tails of this collection.

     Iterates over the tails of this collection. The first value will be this collection and the final one will be an empty collection, with the intervening values the results of successive applications of `tail`.

     returns

       an iterator over all the tails of this collection

     Definition Classes
       TraversableLike
     Example:

     1. `List(1,2,3).tails = Iterator(List(1,2,3), List(2,3), List(3), Nil)`

117. #### def take(n: Int): TraversableView[A, Coll]

     Selects first n elements.

     Selects first n elements.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       Tt number of elements to take from this collection.

     returns

       a collection consisting only of the first `n` elements of this collection, or else the whole collection, if it has less than `n` elements.

     Definition Classes
       TraversableViewLike → TraversableLike → GenTraversableLike

118. #### def takeWhile(p: (A) ⇒ Boolean): TraversableView[A, Coll]

     Takes longest prefix of elements that satisfy a predicate.

     Takes longest prefix of elements that satisfy a predicate.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     p

       The predicate used to test elements.

     returns

       the longest prefix of this collection whose elements all satisfy the predicate `p`.

     Definition Classes
       TraversableViewLike → TraversableLike → GenTraversableLike

119. #### def thisCollection: Traversable[A]

     The underlying collection seen as an instance of `CC`.

     The underlying collection seen as an instance of `CC`. By default this is implemented as the current collection object itself, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       TraversableLike

120. #### def thisSeq: Seq[A]

     Attributes
       protected[this]
     Definition Classes
       ViewMkString

121. #### abstract def toArray: Array[A]

     [use case] Converts this collection to an array.

     [use case]

     Converts this collection to an array.

     Note: will not terminate for infinite-sized collections.

     returns

       an array containing all elements of this collection.

     Definition Classes
       GenTraversableOnce

122. #### def toArray[B >: A](implicit arg0: ClassManifest[B]): Array[B]

     Converts this collection to an array.

     Converts this collection to an array.

     Note: will not terminate for infinite-sized collections.

     B

       the type of the elements of the array. A `ClassManifest` for this type must be available.

     returns

       an array containing all elements of this collection.

     Definition Classes
       TraversableOnce → GenTraversableOnce

123. #### def toBuffer[B >: A]: Buffer[B]

     Converts this collection to a mutable buffer.

     Converts this collection to a mutable buffer.

     Note: will not terminate for infinite-sized collections.

     returns

       a buffer containing all elements of this collection.

     Definition Classes
       TraversableOnce → GenTraversableOnce

124. #### def toCollection(repr: TraversableView[A, Coll]): Traversable[A]

     A conversion from collections of type `Repr` to `CC` objects.

     A conversion from collections of type `Repr` to `CC` objects. By default this is implemented as just a cast, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       TraversableLike

125. #### def toIndexedSeq[B >: A]: IndexedSeq[B]

     Converts this collection to an indexed sequence.

     Converts this collection to an indexed sequence.

     Note: will not terminate for infinite-sized collections.

     returns

       an indexed sequence containing all elements of this collection.

     Definition Classes
       TraversableOnce → GenTraversableOnce

126. #### def toIterable: Iterable[A]

     Converts this collection to an iterable collection.

     Converts this collection to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

     Note: will not terminate for infinite-sized collections.

     returns

       an `Iterable` containing all elements of this collection.

     Definition Classes
       TraversableOnce → GenTraversableOnce

127. #### def toIterator: Iterator[A]

     Returns an Iterator over the elements in this collection.

     Returns an Iterator over the elements in this collection. Will return the same Iterator if this instance is already an Iterator.

     Note: will not terminate for infinite-sized collections.

     returns

       an Iterator containing all elements of this collection.

     Definition Classes
       TraversableLike → GenTraversableOnce

128. #### def toList: List[A]

     Converts this collection to a list.

     Converts this collection to a list.

     Note: will not terminate for infinite-sized collections.

     returns

       a list containing all elements of this collection.

     Definition Classes
       TraversableOnce → GenTraversableOnce

129. #### abstract def toMap[T, U]: Map[T, U]

     [use case] Converts this collection to a map.

     [use case]

     Converts this collection to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     Note: will not terminate for infinite-sized collections.

     returns

       a map containing all elements of this collection.

     Definition Classes
       GenTraversableOnce

130. #### def toMap[T, U](implicit ev: <:<[A, (T, U)]): Map[T, U]

     Converts this collection to a map.

     Converts this collection to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     Note: will not terminate for infinite-sized collections.

     returns

       a map containing all elements of this collection.

     Definition Classes
       TraversableOnce → GenTraversableOnce

131. #### def toSeq: Seq[A]

     Converts this collection to a sequence.

     Converts this collection to a sequence. As with `toIterable`, it's lazy in this default implementation, as this `TraversableOnce` may be lazy and unevaluated.

     Note: will not terminate for infinite-sized collections.

     returns

       a sequence containing all elements of this collection.

     Definition Classes
       TraversableOnce → GenTraversableOnce

132. #### def toSet[B >: A]: Set[B]

     Converts this collection to a set.

     Converts this collection to a set.

     Note: will not terminate for infinite-sized collections.

     returns

       a set containing all elements of this collection.

     Definition Classes
       TraversableOnce → GenTraversableOnce

133. #### def toStream: Stream[A]

     Converts this collection to a stream.

     Converts this collection to a stream.

     Note: will not terminate for infinite-sized collections.

     returns

       a stream containing all elements of this collection.

     Definition Classes
       TraversableLike → GenTraversableOnce

134. #### def toString(): String

     Converts this collection to a string.

     Converts this collection to a string.

     returns

       a string representation of this collection. By default this string consists of the `stringPrefix` of this collection, followed by all elements separated by commas and enclosed in parentheses.

     Definition Classes
       TraversableViewLike → TraversableLike → AnyRef → Any

135. #### def toTraversable: Traversable[A]

     Converts this collection to an unspecified Traversable.

     Converts this collection to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

     Note: will not terminate for infinite-sized collections.

     returns

       a Traversable containing all elements of this collection.

     Definition Classes
       TraversableLike → TraversableOnce → GenTraversableOnce

136. #### def transpose[B](implicit asTraversable: (A) ⇒ GenTraversableOnce[B]): Traversable[Traversable[B]]

     Transposes this collection of traversable collections into a collection of collections.

     Transposes this collection of traversable collections into a collection of collections.

     B

       the type of the elements of each traversable collection.

     asTraversable

       an implicit conversion which asserts that the element type of this collection is a `Traversable`.

     returns

       a two-dimensional collection of collections which has as nth row the nth column of this collection.

     Definition Classes
       GenericTraversableTemplate
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) `transpose` throws an `IllegalArgumentException` if collections are not uniformly sized.

     Exceptions thrown
       `IllegalArgumentException`

       if all collections in this collection are not of the same size.

137. #### def unzip[A1, A2](implicit asPair: (A) ⇒ (A1, A2)): (Traversable[A1], Traversable[A2])

     Converts this collection of pairs into two collections of the first and second half of each pair.

     Converts this collection of pairs into two collections of the first and second half of each pair.

     asPair

       an implicit conversion which asserts that the element type of this collection is a pair.

     returns

       a pair collections, containing the first, respectively second half of each element pair of this collection.

     Definition Classes
       GenericTraversableTemplate

138. #### def unzip3[A1, A2, A3](implicit asTriple: (A) ⇒ (A1, A2, A3)): (Traversable[A1], Traversable[A2], Traversable[A3])

     Converts this collection of triples into three collections of the first, second, and third element of each triple.

     Converts this collection of triples into three collections of the first, second, and third element of each triple.

     asTriple

       an implicit conversion which asserts that the element type of this collection is a triple.

     returns

       a triple collections, containing the first, second, respectively third member of each element triple of this collection.

     Definition Classes
       GenericTraversableTemplate

139. #### def view(from: Int, until: Int): TraversableView[A, TraversableView[A, Coll]]

     Creates a non-strict view of a slice of this collection.

     Creates a non-strict view of a slice of this collection.

     Note: the difference between `view` and `slice` is that `view` produces a view of the current collection, whereas `slice` produces a new collection.

     Note: `view(from, to)` is equivalent to `view.slice(from, to)`

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     from

       the index of the first element of the view

     until

       the index of the element following the view

     returns

       a non-strict view of a slice of this collection, starting at index `from` and extending up to (but not including) index `until`.

     Definition Classes
       TraversableLike

140. #### def view: TraversableView[A, TraversableView[A, Coll]]

     Creates a non-strict view of this collection.

     Creates a non-strict view of this collection.

     returns

       a non-strict view of this collection.

     Definition Classes
       TraversableLike

141. #### def viewIdString: String

     Attributes
       protected[this]
     Definition Classes
       TraversableViewLike → GenTraversableViewLike

142. #### def viewIdentifier: String

     Attributes
       protected[this]
     Definition Classes
       TraversableViewLike → GenTraversableViewLike

143. #### def viewToString: String

     Definition Classes
       GenTraversableViewLike

144. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

145. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

146. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

147. #### def withFilter(p: (A) ⇒ Boolean): TraversableView[A, Coll]

     Creates a non-strict filter of this collection.

     Creates a non-strict filter of this collection.

     Note: the difference between `c filter p` and `c withFilter p` is that the former creates a new collection, whereas the latter only restricts the domain of subsequent `map`, `flatMap`, `foreach`, and `withFilter` operations.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     p

       the predicate used to test elements.

     returns

       an object of class `WithFilter`, which supports `map`, `flatMap`, `foreach`, and `withFilter` operations. All these operations apply to those elements of this collection which satisfy the predicate `p`.

     Definition Classes
       TraversableViewLike → TraversableLike → FilterMonadic

### Inherited from GenTraversableView[A, Coll]

### Inherited from TraversableViewLike[A, Coll, TraversableView[A, Coll]]

### Inherited from GenTraversableViewLike[A, Coll, TraversableView[A, Coll]]

### Inherited from ViewMkString[A]

### Inherited from Traversable[A]

### Inherited from GenTraversable[A]

### Inherited from GenericTraversableTemplate[A, Traversable]

### Inherited from TraversableLike[A, TraversableView[A, Coll]]

### Inherited from GenTraversableLike[A, TraversableView[A, Coll]]

### Inherited from Parallelizable[A, ParIterable[A]]

### Inherited from TraversableOnce[A]

### Inherited from GenTraversableOnce[A]

### Inherited from FilterMonadic[A, TraversableView[A, Coll]]

### Inherited from HasNewBuilder[A, TraversableView[A, Coll]]

### Inherited from AnyRef

### Inherited from Any